{-# OPTIONS -Wall #-}
module Language.Barracuda
  ( module Language.Barracuda.AST
  , module Language.Barracuda.SmartConstructors
  , module Language.Barracuda.Function
  , module Language.Barracuda.Evaluator
  , module Language.Barracuda.Compiler
  ) where

import Language.Barracuda.AST (SExpr, AExpr, MExpr, Scalar)
import Language.Barracuda.SmartConstructors
  ( int
  , float
  , bool
  , true
  , false
  , intToFloat
  , idiv
  , imod
  , (&&*)
  , (||*)
  , snot
  , ExprEq ((==*), (/=*))
  , ExprOrd ((>*), (>=*), (<*), (<=*))
  , minVal
  , maxVal
  , ExprIndexable ((!))
  , Idx
  , scond
  , slet
  , azipWith
  , azipWith3
  , amap
  , areduce
  , asum
  , alength
  , aslice
  , mmap
  , mzipWith
  , mreduce
  , mrows
  , mcols
  , mslice
  )
import Language.Barracuda.Function
  ( Function (Function)
  , functionName
  , Instantiable
  )
import Language.Barracuda.Evaluator ( evalSExpr, evalAExpr )
import Language.Barracuda.Compiler
  ( CompileConfig (CppTarget, CudaTarget)
  , CppConfig     (CppConfig)
  , CudaConfig    (CudaConfig)
  , sharedMemoryOptimization
  , defaultCudaConfig
  , defaultCppConfig
  , CompileTarget (Cpp, Cuda)
  , compile
  )
