module Main (main) where

import Language.Barracuda

addOne :: MExpr Float -> MExpr Float
addOne x = mmap (+ 1) x

cpuAddOne = [Function addOne "cpu_add1_2d" ["input"] "result"]
gpuAddOne = [Function addOne "gpu_add1_2d" ["input"] "result"]

main :: IO ()
main = do
  compile defaultCppConfig ("cpu_add1_2d.hpp", "cpu_add1_2d.cpp") cpuAddOne
  compile defaultCudaConfig ("gpu_add1_2d.hpp", "gpu_add1_2d.cu")  gpuAddOne
