module Main (main) where

import Language.Barracuda

addOne :: AExpr Float -> AExpr Float
addOne x = amap (+ 1) x

cpuAdd1 = [Function addOne "cpu_add1" ["input"] "result"]
gpuAdd1 = [Function addOne "gpu_add1" ["input"] "result"]

main :: IO ()
main = do
  compile defaultCppConfig ("cpu_add1.hpp", "cpu_add1.cpp") cpuAdd1
  compile defaultCudaConfig ("gpu_add1.hpp", "gpu_add1.cu")  gpuAdd1
