#include "gpu_add_matrices.hpp"
#include "cpu_add_matrices.hpp"
#include "barracuda_test.hpp"


bool test_add_matrices (float_gen &generator,
                        const unsigned rows,
                        const unsigned cols)
{
  const float_test_array initVals1 = new_test_array(generator, rows * cols);
  const float_test_array initVals2 = new_test_array(generator, rows * cols);

  const gpu_float_matrix gpu_x(rows, cols, initVals1.get());
  const gpu_float_matrix gpu_y(rows, cols, initVals2.get());
  gpu_float_matrix gpu_result(rows, cols);

  const float_matrix cpu_x(rows, cols, initVals1.get());
  const float_matrix cpu_y(rows, cols, initVals2.get());
  float_matrix cpu_result(rows, cols);

  gpu_add_matrices(gpu_x, gpu_y, gpu_result);
  cpu_add_matrices(cpu_x, cpu_y, cpu_result);

  return compare_matrices(float_matrix(gpu_result), cpu_result);
}
