module Main (main) where

import Language.Barracuda

add :: MExpr Float -> MExpr Float -> MExpr Float
add = mzipWith (+)

cpuAdd :: [Function]
cpuAdd = [Function add "cpu_add_matrices" ["x", "y"] "result"]

gpuAdd :: [Function]
gpuAdd = [Function add "gpu_add_matrices" ["x", "y"] "result"]

main :: IO ()
main = do
  compile defaultCppConfig ("cpu_add_matrices.hpp", "cpu_add_matrices.cpp") cpuAdd
  compile defaultCudaConfig ("gpu_add_matrices.hpp", "gpu_add_matrices.cu")  gpuAdd
