#include "gpu_forward_diff_shmem.hpp"
#include "gpu_forward_diff_noshmem.hpp"
#include "cpu_forward_diff.hpp"
#include "barracuda_test.hpp"

bool test_forward_diff(float_gen &generator, const unsigned len)
{
  const float_test_array initVals = new_test_array(generator, len);

  const gpu_float_array gpu_noshmem_x(len, initVals.get());
  gpu_float_array gpu_noshmem_result(len, initVals.get());

  const gpu_float_array gpu_shmem_x(len, initVals.get());
  gpu_float_array gpu_shmem_result(len, initVals.get());

  const float_array cpu_x(len, initVals.get());
  float_array cpu_result(len, initVals.get());

  gpu_noshmem_forward_diff (
      gpu_noshmem_x,
      gpu_float_array_view(gpu_noshmem_result, slice(0, len - 1, 1))
      );
  gpu_shmem_forward_diff (
      gpu_shmem_x,
      gpu_float_array_view(gpu_shmem_result, slice(0, len - 1, 1))
      );
  cpu_forward_diff (
      cpu_x,
      float_array_view(cpu_result, slice(0, len - 1, 1))
      );

  return
      compare_arrays(float_array(gpu_noshmem_result), cpu_result) &&
      compare_arrays(float_array(gpu_shmem_result), cpu_result);
}
