module Main (main) where

import Language.Barracuda

-- | The maximum difference computation, to determine convergence.
jacobiDiff :: MExpr Float -> MExpr Float -> SExpr Float
jacobiDiff a1 a2 = mreduce maxVal (-1e12) diffArr
  where
    diffArr = mzipWith (\x y -> abs (x - y)) a1 a2

jacobiTest :: String -> [Function]
jacobiTest p = [Function jacobiDiff name ["array1", "array2"] "result"]
  where name = p ++ "_jacobi_diff"

main :: IO ()
main = do
  compile defaultCppConfig ("cpu_jacobi_diff.hpp", "cpu_jacobi_diff.cpp") (jacobiTest "cpu")
  compile defaultCudaConfig ("gpu_jacobi_diff.hpp", "gpu_jacobi_diff.cu")  (jacobiTest "gpu")
