#include "gpu_matrix_max.hpp"
#include "cpu_matrix_max.hpp"
#include "barracuda_test.hpp"


bool test_matrix_max (float_gen &generator,
                      const unsigned rows,
                      const unsigned cols)
{
  const float_test_array initVals1 = new_test_array(generator, rows * cols);

  const gpu_float_matrix gpu_input1(rows, cols, initVals1.get());
  float gpu_result;

  const float_matrix cpu_input1(rows, cols, initVals1.get());
  float cpu_result;

  gpu_matrix_max(gpu_input1, gpu_result);
  cpu_matrix_max(cpu_input1, cpu_result);

  return compare(cpu_result, gpu_result);
}
