module Main (main) where

import Language.Barracuda

-- | Root Mean Square Error.
rmse :: AExpr Float -> AExpr Float -> SExpr Float
rmse x y = sqrt (sumDiff / len)
  where
    len = intToFloat (alength x)
    sumDiff = asum $ amap (\v -> slet v (^2)) $ azipWith (-) x y

cpuRmse = [Function rmse "cpu_rmse" ["input1", "input2"] "result"]
gpuRmse = [Function rmse "gpu_rmse" ["input1", "input2"] "result"]

main :: IO ()
main = do
  compile defaultCppConfig ("cpu_rmse.hpp", "cpu_rmse.cpp") cpuRmse
  compile defaultCudaConfig ("gpu_rmse.hpp", "gpu_rmse.cu")  gpuRmse
