#include "gpu_saxpy.hpp"
#include "cpu_saxpy.hpp"
#include "barracuda_test.hpp"

bool test_saxpy (float_gen &generator, const unsigned len)
{
  const float_test_array initVals1 = new_test_array(generator, len);
  const float_test_array initVals2 = new_test_array(generator, len);

  const float alpha = generator();

  const gpu_float_array gpu_x(len, initVals1.get());
  const gpu_float_array gpu_y(len, initVals2.get());
  gpu_float_array gpu_result(len);

  const float_array cpu_x(len, initVals1.get());
  const float_array cpu_y(len, initVals2.get());
  float_array cpu_result(len);

  gpu_saxpy(alpha, gpu_x, gpu_y, gpu_result);
  cpu_saxpy(alpha, cpu_x, cpu_y, cpu_result);

  return (compare_arrays(float_array(gpu_result), cpu_result));
}
