module Main (main) where

import Language.Barracuda

-- | SAXPY from BLAS Level 1.
saxpy :: SExpr Float -> AExpr Float -> AExpr Float -> AExpr Float
saxpy a x y = azipWith (+) (amap (* a) x) y

cpuSaxpy = [Function saxpy "cpu_saxpy" ["alpha", "x", "y"] "result"]
gpuSaxpy = [Function saxpy "gpu_saxpy" ["alpha", "x", "y"] "result"]

main :: IO ()
main = do
  compile defaultCppConfig ("cpu_saxpy.hpp", "cpu_saxpy.cpp") cpuSaxpy
  compile defaultCudaConfig ("gpu_saxpy.hpp", "gpu_saxpy.cu")  gpuSaxpy
