#include "gpu_noshmem_shift_rows.hpp"
#include "gpu_shmem_shift_rows.hpp"
#include "cpu_shift_rows.hpp"
#include "barracuda_test.hpp"


bool test_shift_rows (float_gen &generator,
                      const unsigned rows,
                      const unsigned cols)
{
  const float_test_array initVals1 = new_test_array(generator, rows * cols);

  const gpu_float_matrix gpu_noshmem_input(rows, cols, initVals1.get());
  gpu_float_matrix gpu_noshmem_result(rows - 1, cols);

  const gpu_float_matrix gpu_shmem_input(rows, cols, initVals1.get());
  gpu_float_matrix gpu_shmem_result(rows - 1, cols);

  const float_matrix cpu_input(rows, cols, initVals1.get());
  float_matrix cpu_result(rows - 1, cols);

  gpu_noshmem_shift_rows(gpu_noshmem_input, gpu_noshmem_result);
  gpu_shmem_shift_rows(gpu_shmem_input, gpu_shmem_result);
  cpu_shift_rows(cpu_input, cpu_result);

  return
      compare_matrices(float_matrix(gpu_noshmem_result), cpu_result) &&
      compare_matrices(float_matrix(gpu_shmem_result), cpu_result);
}
