module Main (main) where

import Language.Barracuda

shiftRows :: MExpr Float -> MExpr Float
shiftRows m = mzipWith (+) m' m''
  where m'  = mslice m (1, mrows m, 1) (0, mcols m, 1)
        m'' = mslice m (0, mrows m - 1, 1) (0, mcols m, 1)

fun :: String -> [Function]
fun p = [Function shiftRows (p ++ "_shift_rows") ["x"] "result"]

main :: IO ()
main = do
  compile defaultCppConfig ("cpu_shift_rows.hpp", "cpu_shift_rows.cpp") (fun "cpu")
  compile defaultCudaConfig
    ("gpu_noshmem_shift_rows.hpp", "gpu_noshmem_shift_rows.cu")
    (fun "gpu_noshmem")
  compile (CudaTarget CudaConfig { sharedMemoryOptimization = True })
    ("gpu_shmem_shift_rows.hpp", "gpu_shmem_shift_rows.cu")
    (fun "gpu_shmem")
