#ifndef TEST_CASES_HPP
#define TEST_CASES_HPP

#define ARRAY_TEST(name) \
  bool name(float_gen &gen, const unsigned len)
#define MATRIX_TEST(name) \
  bool name(float_gen &gen, const unsigned rows, const unsigned cols)


ARRAY_TEST(test_forward_diff);
ARRAY_TEST(test_saxpy);
ARRAY_TEST(test_add1);
ARRAY_TEST(test_rmse);
ARRAY_TEST(test_add_sum);
ARRAY_TEST(test_black_scholes);

MATRIX_TEST(test_add1_2d);
MATRIX_TEST(test_add_matrices);
MATRIX_TEST(test_add_matrices3);
MATRIX_TEST(test_row_shift_multiply);
MATRIX_TEST(test_col_shift_multiply);
MATRIX_TEST(test_jacobi_stencil);
MATRIX_TEST(test_jacobi_diff);
MATRIX_TEST(test_matrix_sum);
MATRIX_TEST(test_matrix_max);

#undef MATRIX_TEST
#undef ARRAY_TEST

#endif
